<template>

  <v-navigation-drawer
    id="app-drawer"
    v-model="inputValue"
    app
    dark
    floating
    persistent
    mobile-break-point="991"
    width="260"
  >

    <v-layout
      class="fill-height"
      tag="v-list"
      column
    >
   
      <v-list-item
        v-for="(link, i) in menu"
        :key="i"
        :to="link.to"
        :active-class="color"
    
        class="v-list-item "
      >
        <v-list-item-action>
          <v-icon>{{ link.icon }}</v-icon>
        </v-list-item-action>
        <v-list-item-title
          v-text="link.text"
        />
      </v-list-item>
    
    <div class="drawer__footer d-flex justify-center">
      <v-btn color="success" @click="onLogout">Выход</v-btn>
    </div>
    </v-layout>
    
  </v-navigation-drawer>
</template>

<script>
// Utilities
import {
  mapMutations,
  mapState
} from 'vuex'

import Role from '@/utils/Role';

export default {
  props: {
    opened: {
      type: Boolean,
      default: false
    }
  },
  data: () => ({
    logo: 'favicon.ico',
    links: [
      {
        to: '/',
        icon: 'mdi-view-dashboard',
        text: 'Главная',
        access: '*'
      },
      {
        to: '/user-profile',
        icon: 'mdi-account',
        text: 'Профиль',
        access: '*'
      },
      {
        to: '/test/create',
        icon: 'mdi-plus',
        text: 'Новый тест',
        access: [Role.Teacher]
      },
      {
        to: '/test/list',
        icon: 'mdi-view-list',
        text: 'Список тестов',
        access: [Role.Teacher]
      },
      {
        to: '/results',
        icon: 'mdi-view-list',
        text: 'Результаты',
        access: [Role.Student]
      },

    ]
  }),
  computed: {
    ...mapState('app', ['image', 'color']),
    ...mapState('user', ['role']),
    inputValue: {
      get () {
        return this.$store.state.app.drawer
      },
      set (val) {
        this.setDrawer(val)
      }
    },
    menu() {
      console.log(this.links)
      // debugger
      return this.links.filter(link => link.access.includes(this.role) || link.access === '*');
    },
    items () {
      return this.$t('Layout.View.items')
    },
    
  },

  methods: {
    ...mapMutations('app', ['setDrawer', 'toggleDrawer']),
    async onLogout() {
      await this.$store.dispatch('user/clearTokens');
      this.$router.push('/auth');
    }
  }
}
</script>

<style lang="scss">
  #app-drawer {
    .v-list-item {
      max-height: 60px;
    }
    .v-list__item {
      border-radius: 4px;
      max-height: 40px;
      &--buy {
        margin-top: auto;
        margin-bottom: 17px;
      }
    }
  }
  .drawer__footer {
    margin-top: auto;
    padding: 15px;
  }
</style>
